#pragma once

#include <string>

namespace database_handler::v2
{
    const std::string CREATE_TABLE_BOOKMAKERS
    {
        "CREATE TABLE bookmakers( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL, "
        "logo TEXT "
        "); "
        
	};
    
    const std::string CREATE_TABLE_COACHES
    {
        "CREATE TABLE coaches( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_country_id INTEGER NOT NULL, "
        "common_name TEXT NOT NULL, "
        "fullname TEXT NOT NULL, "
        "firstname TEXT, "
        "lastname TEXT, "
        "nationality TEXT NOT NULL, "
        "birthdate TEXT, "
        "birthcountry TEXT, "
        "birthplace TEXT, "
        "image_path TEXT, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_country_id) REFERENCES countries(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_COMMENTARIES
    {
        "CREATE TABLE commentaries( "
        "id INTEGER PRIMARY KEY, "
        "sm_fixture_id INTEGER NOT NULL, "
        "important BOOLEAN NOT NULL, "
        "order_ INTEGER NOT NULL, "
        "goal BOOLEAN NOT NULL, "
        "minute INTEGER NOT NULL, "
        "extra_minute INTEGER, "
        "comment TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_fixture_id) REFERENCES fixtures(sm_id), "
        "UNIQUE(sm_fixture_id, order_, minute, comment) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_CONTINENTS
    {
        "CREATE TABLE continents( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL UNIQUE "
        "); "
        
	};
    
    const std::string CREATE_TABLE_COUNTRIES
    {
        "CREATE TABLE countries( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_continent_id INTEGER, "
        "name TEXT NOT NULL UNIQUE, "
        "image_path TEXT, "
        " "
        "FOREIGN KEY(sm_continent_id) REFERENCES continents(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_FIXTURES
    {
        "CREATE TABLE fixtures( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_league_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER NOT NULL, "
        "sm_round_id INTEGER NOT NULL, "
        "sm_group_id INTEGER, "
        "sm_aggregate_id INTEGER, "
        "sm_venue_id INTEGER, "
        "sm_referee_id INTEGER, "
        "sm_localteam_id INTEGER NOT NULL, "
        "sm_visitorteam_id INTEGER NOT NULL, "
        "sm_winner_team_id INTEGER, "
        "weather_code TEXT, "
        "weather_type TEXT, "
        "weather_icon TEXT, "
        "weather_temp_cel REAL, "
        "weather_temp_fah REAL, "
        "weather_clouds TEXT, "
        "weather_humidity TEXT, "
        "weather_pressure INTEGER, "
        "weather_wind_speed TEXT, "
        "weather_wind_degree INTEGER, "
        "weather_coordinates_lat REAL, "
        "weather_coordinates_lon REAL, "
        "weather_updated_at TEXT, "
        "commentaries BOOLEAN NOT NULL, "
        "attendance INTEGER, "
        "pitch TEXT, "
        "details TEXT, "
        "neutral_venue BOOLEAN NOT NULL, "
        "winning_odds_calculated BOOLEAN NOT NULL, "
        "localteam_formation TEXT, "
        "visitorteam_formation TEXT, "
        "localteam_score INTEGER NOT NULL, "
        "visitorteam_score INTEGER NOT NULL, "
        "localteam_pen_score INTEGER, "
        "visitorteam_pen_score INTEGER, "
        "ht_score TEXT, "
        "ft_score TEXT NOT NULL, "
        "et_score TEXT, "
        "ps_score TEXT, "
        "status TEXT NOT NULL, "
        "date_time TEXT NOT NULL /* date */, "
        "date TEXT NOT NULL, "
        "time TEXT NOT NULL, "
        "timestamp INTEGER NOT NULL, "
        "timezone TEXT NOT NULL, "
        "minute INTEGER NOT NULL, "
        "second INTEGER, "
        "added_time INTEGER, "
        "extra_minute INTEGER, "
        "injury_time INTEGER, "
        "sm_localteam_coach_id INTEGER, "
        "sm_visitorteam_coach_id INTEGER, "
        "localteam_position INTEGER, "
        "visitorteam_position INTEGER, "
        "sm_first_assistant_id INTEGER, "
        "sm_second_assistant_id INTEGER, "
        "sm_fourth_official_id INTEGER, "
        "leg TEXT NOT NULL, "
        "localteam_color TEXT, "
        "localteam_kit_color TEXT, "
        "visitorteam_color TEXT, "
        "visitorteam_kit_color TEXT, "
        "deleted BOOLEAN NOT NULL, "
        " "
        "FOREIGN KEY(sm_league_id) REFERENCES leagues(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "FOREIGN KEY(sm_round_id) REFERENCES rounds(sm_id), "
        "FOREIGN KEY(sm_venue_id) REFERENCES venues(sm_id), "
        "FOREIGN KEY(sm_referee_id) REFERENCES referees(sm_id), "
        "FOREIGN KEY(sm_localteam_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_visitorteam_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_winner_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_localteam_coach_id) REFERENCES coaches(sm_id), "
        "FOREIGN KEY(sm_visitorteam_coach_id) REFERENCES coaches(sm_id), "
        "FOREIGN KEY(sm_first_assistant_id) REFERENCES assistants(sm_id), "
        "FOREIGN KEY(sm_second_assistant_id) REFERENCES assistants(sm_id), "
        "FOREIGN KEY(sm_fourth_official_id) REFERENCES assistants(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_FIXTURE_SIDELINES
    {
        "CREATE TABLE fixture_sidelines( "
        "id INTEGER PRIMARY KEY, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_fixture_id INTEGER NOT NULL, "
        "sm_player_id INTEGER NOT NULL, "
        "player_name TEXT NOT NULL, "
        "reason TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_fixture_id) REFERENCES fixtures(sm_id), "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "UNIQUE(sm_team_id, sm_fixture_id, sm_player_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_GOAL_LINES
    {
        "CREATE TABLE goal_lines( "
        "id INTEGER PRIMARY KEY, "
        "sm_season_statistics_id INTEGER NOT NULL, "
        "line_over TEXT NOT NULL, "
        "percentage REAL NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_statistics_id) REFERENCES season_statistics(sm_id), "
        "UNIQUE(sm_season_statistics_id, line_over) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_GOALS_SCORED_MINUTES
    {
        "CREATE TABLE goals_scored_minutes( "
        "id INTEGER PRIMARY KEY, "
        "sm_season_statistics_id INTEGER NOT NULL, "
        "interval TEXT NOT NULL, "
        "percentage REAL NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_statistics_id) REFERENCES season_statistics(sm_id), "
        "UNIQUE(sm_season_statistics_id, interval) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_LEAGUES
    {
        "CREATE TABLE leagues( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "active BOOLEAN NOT NULL, "
        "type TEXT, "
        "sm_legacy_id INTEGER, "
        "sm_country_id INTEGER NOT NULL, "
        "logo_path TEXT, "
        "name TEXT NOT NULL, "
        "is_cup BOOLEAN NOT NULL, "
        "sm_current_season_id INTEGER NOT NULL, "
        "sm_current_round_id INTEGER, "
        "sm_current_stage_id INTEGER, "
        "live_standings BOOLEAN NOT NULL, "
        "coverage_predictions BOOLEAN NOT NULL, "
        "coverage_topscorer_goals BOOLEAN NOT NULL, "
        "coverage_topscorer_assists BOOLEAN NOT NULL, "
        "coverage_topscorer_cards BOOLEAN NOT NULL, "
        " "
        "FOREIGN KEY(sm_country_id) REFERENCES countries (sm_id), "
        "FOREIGN KEY(sm_current_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_current_round_id) REFERENCES rounds(sm_id), "
        "FOREIGN KEY(sm_current_stage_id) REFERENCES stage(sm_id), "
        "UNIQUE (sm_country_id, name) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_LINEUPS
    {
        "CREATE TABLE lineups( "
        "id INTEGER PRIMARY KEY, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_fixture_id INTEGER NOT NULL, "
        "sm_player_id INTEGER NOT NULL, "
        "player_name TEXT NOT NULL, "
        "number INT NOT NULL, "
        "position TEXT NOT NULL, "
        "additional_position TEXT, "
        "formation_position INT, "
        "posx INT, "
        "posy INT, "
        "captain BOOLEAN, "
        "type TEXT NOT NULL, "
        "shots_total INT, "
        "shots_on_goal INT, "
        "goals_scored INT, "
        "goals_assists INT, "
        "goals_conceded INT, "
        "goals_owngoals INT, "
        "fouls_drawn INT, "
        "fouls_committed INT, "
        "yellowcards INT, "
        "redcards INT, "
        "yellowredcards INT, "
        "passing_total_crosses INT, "
        "passing_crosses_accuracy INT, "
        "passing_passes INT, "
        "passing_accurate_passes INT, "
        "passing_passes_accuracy INT, "
        "passing_key_passes INT, "
        "dribbles_attempts INT, "
        "dribbles_success INT, "
        "dribbles_dribbled_past INT, "
        "duels_total INT, "
        "duels_won INT, "
        "aerials_won INT, "
        "punches INT, "
        "offsides INT, "
        "saves INT, "
        "inside_box_saves INT, "
        "penalty_scored INT, "
        "penalty_missed INT, "
        "penalty_saved INT, "
        "penalty_committed INT, "
        "penalty_won INT, "
        "hit_woodwork INT, "
        "tackles INT, "
        "blocks INT, "
        "interceptions INT, "
        "clearances INT, "
        "dispossesed INT, "
        "minutes_played INT, "
        "rating REAL, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_fixture_id) REFERENCES fixtures(sm_id), "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "UNIQUE(sm_fixture_id, sm_team_id, sm_player_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_MARKETS
    {
        "CREATE TABLE markets( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL "
        "); "
        
	};
    
    const std::string CREATE_TABLE_MATCH_STATISTICS
    {
        "CREATE TABLE match_statistics( "
        "id INTEGER PRIMARY KEY, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_fixture_id INTEGER NOT NULL, "
        "shots_total INT, "
        "shots_ongoal INT, "
        "shots_offgoal INT, "
        "shots_blocked INT, "
        "shots_insidebox INT, "
        "shots_outsidebox INT, "
        "passes_total INT, "
        "passes_accurate INT, "
        "passes_percentage REAL, "
        "attacks INT, "
        "dangerous_attacks INT, "
        "fouls INT, "
        "corners INT, "
        "offsides INT, "
        "possessiontime INT, "
        "yellowcards INT, "
        "redcards INT, "
        "yellowredcards INT, "
        "saves INT, "
        "substitutions INT, "
        "goal_kick INT, "
        "throw_in INT, "
        "ball_safe INT, "
        "goals INT, "
        "penalties INT, "
        "injuries INT, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "UNIQUE(sm_fixture_id, sm_team_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_ODDS
    {
        "CREATE TABLE odds( "
        "id INTEGER PRIMARY KEY, "
        "sm_fixture_id INTEGER NOT NULL, "
        "sm_market_id INTEGER NOT NULL, "
        "sm_bookmaker_id INTEGER NOT NULL, "
        "suspended BOOLEAN NOT NULL, "
        "label TEXT NOT NULL, "
        "value REAL NOT NULL, "
        "probability REAL, "
        "dp3 TEXT, "
        "american INTEGER NOT NULL, "
        "fractional TEXT, "
        "winning BOOLEAN, "
        "handicap TEXT, "
        "total TEXT, "
        "stop BOOLEAN NOT NULL, "
        "bookmaker_event_id INTEGER, "
        "last_update TEXT NOT NULL, "
        "timezone_type INTEGER, "
        "timezone TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_fixture_id) REFERENCES fixtures(sm_id), "
        "FOREIGN KEY(sm_market_id) REFERENCES markets(sm_id), "
        "FOREIGN KEY(sm_bookmaker_id) REFERENCES bookmakers(sm_id), "
        "UNIQUE(sm_fixture_id, sm_market_id, sm_bookmaker_id, last_update) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_PLAYER_PERFORMANCES
    {
        "CREATE TABLE player_performances( "
        "id INTEGER PRIMARY KEY, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "number INTEGER NOT NULL, "
        "captain INTEGER NOT NULL, "
        "injured BOOLEAN NOT NULL, "
        "minutes INTEGER NOT NULL, "
        "appearences INTEGER NOT NULL, "
        "lineups INTEGER NOT NULL, "
        "substitute_in INTEGER NOT NULL, "
        "substitute_out INTEGER NOT NULL, "
        "substitutes_on_bench INTEGER NOT NULL, "
        "goals INTEGER NOT NULL, "
        "assists INTEGER NOT NULL, "
        "saves INTEGER, "
        "inside_box_saves INTEGER, "
        "dispossesed INTEGER, "
        "interceptions INTEGER, "
        "yellowcards INTEGER NOT NULL, "
        "yellowred INTEGER NOT NULL, "
        "redcards INTEGER NOT NULL, "
        "tackles INTEGER, "
        "blocks INTEGER, "
        "hit_post INTEGER, "
        "fouls_committed INTEGER, "
        "fouls_drawn INTEGER, "
        "crosses_total INTEGER, "
        "crosses_accurate INTEGER, "
        "dribbles_attempts INTEGER, "
        "dribbles_success INTEGER, "
        "dribbled_past INTEGER, "
        "duels_total INTEGER, "
        "duels_won INTEGER, "
        "passes_total INTEGER, "
        "passes_accuracy REAL, "
        "key_passes INTEGER, "
        "penalties_won INTEGER, "
        "penalties_scored INTEGER, "
        "penalties_missed INTEGER, "
        "penalties_committed INTEGER, "
        "penalties_saved INTEGER, "
        "shots_total INTEGER, "
        "shots_on_target INTEGER, "
        "shots_off_target INTEGER, "
        " "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "UNIQUE(sm_player_id, sm_season_id, sm_team_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_PLAYERS
    {
        "CREATE TABLE players( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_country_id INTEGER, "
        "sm_position_id INTEGER NOT NULL, "
        "common_name TEXT NOT NULL, "
        "display_name TEXT, "
        "fullname TEXT, "
        "firstname TEXT, "
        "lastname TEXT, "
        "nationality TEXT NOT NULL, "
        "birthdate TEXT NOT NULL, "
        "birthcountry TEXT, "
        "birthplace TEXT, "
        "height TEXT, "
        "weight TEXT, "
        "image_path TEXT, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_country_id) REFERENCES countries(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_PLAYER_SIDELINES
    {
        "CREATE TABLE player_sidelines( "
        "id INTEGER PRIMARY KEY, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_season_id INTEGER, "
        "sm_team_id INTEGER, "
        "description TEXT NOT NULL, "
        "start_date TEXT NOT NULL, "
        "end_date TEXT, "
        " "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "UNIQUE(sm_player_id, start_date) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_PLAYER_TRANSFERS
    {
        "CREATE TABLE player_transfers( "
        "id INTEGER PRIMARY KEY, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_from_team_id INTEGER NOT NULL, "
        "sm_to_team_id INTEGER NOT NULL, "
        "sm_season_id INTEGER, "
        "transfer TEXT NOT NULL, "
        "date TEXT NOT NULL /* date */, "
        "amount TEXT, "
        " "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_from_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_to_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "UNIQUE(sm_player_id, date) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_ROUNDS
    {
        "CREATE TABLE rounds( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name INTEGER NOT NULL, "
        "sm_league_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER NOT NULL, "
        "start TEXT NOT NULL, "
        "end TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_league_id) REFERENCES leagues(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE(name, sm_league_id, sm_season_id, sm_stage_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_SEASONS
    {
        "CREATE TABLE seasons( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL, "
        "sm_league_id INTEGER NOT NULL, "
        "is_current_season BOOLEAN NOT NULL, "
        "sm_current_round_id INTEGER, "
        "sm_current_stage_id INTEGER, "
        " "
        "FOREIGN KEY(sm_league_id) REFERENCES leagues(sm_id), "
        "FOREIGN KEY(sm_current_round_id) REFERENCES rounds(sm_id), "
        "FOREIGN KEY(sm_current_stage_id) REFERENCES stages(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_SEASON_STATISTICS
    {
        "CREATE TABLE season_statistics( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_league_id INTEGER NOT NULL, "
        "number_of_clubs INT NOT NULL, "
        "number_of_matches INT NOT NULL, "
        "number_of_matches_played INT NOT NULL, "
        "number_of_goals INT NOT NULL, "
        "matches_both_teams_scored INT NOT NULL, "
        "number_of_yellowcards INT NOT NULL, "
        "number_of_yellowredcards INT NOT NULL, "
        "number_of_redcards INT NOT NULL, "
        "avg_goals_per_match REAL, "
        "avg_yellowcards_per_match REAL, "
        "avg_yellowredcards_per_match REAL, "
        "avg_redcards_per_match REAL, "
        "sm_team_with_most_goals_id INTEGER, "
        "sm_team_with_most_conceded_goals_id INTEGER, "
        "sm_team_with_most_goals_per_match_id INTEGER, "
        "sm_season_topscorer_id INTEGER, "
        "season_topscorer_number INT, "
        "sm_season_assist_topscorer_id INTEGER, "
        "season_assist_topscorer_number INT, "
        "sm_team_most_cleansheets_id INTEGER, "
        "team_most_cleansheets_number INT, "
        "sm_goalkeeper_most_cleansheets_id INTEGER, "
        "goalkeeper_most_cleansheets_number INT, "
        "goal_scored_every_minutes INT NOT NULL, "
        "btts REAL, "
        "avg_corners_per_match REAL, "
        "team_most_corners_count INT, "
        "sm_team_most_corners_id INTEGER, "
        "win_percentage_home REAL, "
        "win_percentage_away REAL, "
        "draw_percentage REAL, "
        "avg_homegoals_per_match REAL, "
        "avg_awaygoals_per_match REAL, "
        "avg_player_rating REAL, "
        "updated_date TEXT NOT NULL, "
        "timezone_type INT NOT NULL, "
        "timezone TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_league_id) REFERENCES leagues(sm_id), "
        "FOREIGN KEY(sm_team_with_most_goals_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_team_with_most_conceded_goals_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_team_with_most_goals_per_match_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_season_topscorer_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_season_assist_topscorer_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_team_most_cleansheets_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_goalkeeper_most_cleansheets_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_team_most_corners_id) REFERENCES teams(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_STAGES
    {
        "CREATE TABLE stages( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL, "
        "type TEXT NOT NULL, "
        "sm_league_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sort_order INTEGER, "
        "has_standings BOOLEAN NOT NULL, "
        " "
        "FOREIGN KEY(sm_league_id) REFERENCES leagues(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "UNIQUE(sm_season_id, name) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_STANDING_POSITIONS
    {
        "CREATE TABLE standing_positions( "
        "id INTEGER PRIMARY KEY, "
        "sm_standing_id INTEGER NOT NULL, "
        "position INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "team_name TEXT NOT NULL, "
        "sm_round_id INTEGER NOT NULL, "
        "round_name INTEGER NOT NULL, "
        "sm_group_id INTEGER, "
        "group_name TEXT, "
        "home_games_played INTEGER NOT NULL, "
        "home_won INTEGER NOT NULL, "
        "home_draw INTEGER NOT NULL, "
        "home_lost INTEGER NOT NULL, "
        "home_goals_scored INTEGER NOT NULL, "
        "home_goals_against INTEGER NOT NULL, "
        "away_games_played INTEGER NOT NULL, "
        "away_won INTEGER NOT NULL, "
        "away_draw INTEGER NOT NULL, "
        "away_lost INTEGER NOT NULL, "
        "away_goals_scored INTEGER NOT NULL, "
        "away_goals_against INTEGER NOT NULL, "
        "result TEXT, "
        "recent_form TEXT, "
        "status TEXT, "
        " "
        "FOREIGN KEY(sm_standing_id) REFERENCES standings(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_round_id) REFERENCES rounds(sm_id), "
        "UNIQUE(sm_standing_id, position) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_STANDINGS
    {
        "CREATE TABLE standings( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL, "
        "sm_league_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_round_id INTEGER NOT NULL, "
        "round_name INTEGER NOT NULL, "
        "type TEXT NOT NULL, "
        "sm_stage_id INTEGER NOT NULL, "
        "stage_name TEXT NOT NULL, "
        "resource TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_league_id) REFERENCES league(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES season(sm_id), "
        "FOREIGN KEY(sm_round_id) REFERENCES rounds(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE(sm_league_id, sm_season_id, sm_round_id, sm_stage_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TEAM_GOAL_LINES
    {
        "CREATE TABLE team_goal_lines( "
        "id INTEGER PRIMARY KEY, "
        "team_season_statistics_id INTEGER NOT NULL, "
        "line_over TEXT NOT NULL, "
        "home_percentage REAL NOT NULL, "
        "away_percentage REAL NOT NULL, "
        " "
        "FOREIGN KEY(team_season_statistics_id) REFERENCES team_season_statistics(id), "
        "UNIQUE(team_season_statistics_id, line_over) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TEAM_GOAL_MINUTES
    {
        "CREATE TABLE team_goal_minutes( "
        "id INTEGER PRIMARY KEY, "
        "team_season_statistics_id INTEGER NOT NULL, "
        "type TEXT NOT NULL, "
        "period TEXT NOT NULL, "
        "count INT NOT NULL, "
        "percentage REAL NOT NULL, "
        " "
        "FOREIGN KEY(team_season_statistics_id) REFERENCES team_season_statistics(id), "
        "UNIQUE(team_season_statistics_id, period, type) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TEAMS
    {
        "CREATE TABLE teams( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_legacy_id INTEGER NULL, "
        "name TEXT NOT NULL, "
        "short_code TEXT, "
        "twitter TEXT, "
        "sm_country_id INTEGER NOT NULL, "
        "national_team BOOLEAN NOT NULL, "
        "founded INTEGER, "
        "logo_path TEXT, "
        "sm_venue_id INTEGER, "
        "sm_current_season_id INTEGER, "
        " "
        "FOREIGN KEY(sm_country_id) REFERENCES countries(sm_id), "
        "FOREIGN KEY(sm_venue_id) REFERENCES venues(sm_id), "
        "FOREIGN KEY(sm_current_season_id) REFERENCES seasons(sm_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TEAM_SEASON_STATISTICS
    {
        "CREATE TABLE team_season_statistics( "
        "id INTEGER PRIMARY KEY, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER NOT NULL DEFAULT 0, "
        "home_wins INT NOT NULL, "
        "away_wins INT NOT NULL, "
        "home_draws INT NOT NULL, "
        "away_draws INT NOT NULL, "
        "home_losses INT NOT NULL, "
        "away_losses INT NOT NULL, "
        "home_goals_for INT NOT NULL, "
        "away_goals_for INT NOT NULL, "
        "home_goals_against INT NOT NULL, "
        "away_goals_against INT NOT NULL, "
        "home_clean_sheet INT NOT NULL, "
        "away_clean_sheet INT NOT NULL, "
        "home_failed_to_score INT NOT NULL, "
        "away_failed_to_score INT NOT NULL, "
        "home_avg_goals_per_game_scored REAL, "
        "away_avg_goals_per_game_scored REAL, "
        "home_avg_goals_per_game_conceded REAL, "
        "away_avg_goals_per_game_conceded REAL, "
        "home_avg_first_goal_scored TEXT NOT NULL, "
        "away_avg_first_goal_scored TEXT NOT NULL, "
        "overall_avg_first_goal_scored TEXT NOT NULL, "
        "home_avg_first_goal_conceded TEXT NOT NULL, "
        "away_avg_first_goal_conceded TEXT NOT NULL, "
        "overall_avg_first_goal_conceded TEXT NOT NULL, "
        "attacks INT, "
        "dangerous_attacks INT, "
        "avg_ball_possession_percentage REAL, "
        "fouls INT, "
        "avg_fouls_per_game REAL, "
        "offsides INT, "
        "redcards INT, "
        "yellowcards INT, "
        "shots_blocked INT, "
        "shots_off_target INT, "
        "avg_shots_off_target_per_game REAL, "
        "shots_on_target INT, "
        "avg_shots_on_target_per_game REAL, "
        "avg_corners REAL, "
        "total_corners INT, "
        "btts REAL, "
        " "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE(sm_team_id, sm_season_id, sm_stage_id) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TOP_ASSIST_SCORERS
    {
        "CREATE TABLE top_assist_scorers( "
        "id INTEGER PRIMARY KEY, "
        "position INT NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER, "
        "assists INT NOT NULL, "
        "type TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE (position, sm_season_id, type) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TOP_CARD_SCORERS
    {
        "CREATE TABLE top_card_scorers( "
        "id INTEGER PRIMARY KEY, "
        "position INT NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER, "
        "yellowcards INT NOT NULL, "
        "redcards INT NOT NULL, "
        "type TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE (position, sm_season_id, type) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TOP_GOAL_SCORERS
    {
        "CREATE TABLE top_goal_scorers( "
        "id INTEGER PRIMARY KEY, "
        "position INT NOT NULL, "
        "sm_season_id INTEGER NOT NULL, "
        "sm_player_id INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "sm_stage_id INTEGER, "
        "goals INT NOT NULL, "
        "penalty_goals INT NOT NULL, "
        "type TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_season_id) REFERENCES seasons(sm_id), "
        "FOREIGN KEY(sm_player_id) REFERENCES players(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "FOREIGN KEY(sm_stage_id) REFERENCES stages(sm_id), "
        "UNIQUE (position, sm_season_id, type) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TREND_POINTS
    {
        "CREATE TABLE trend_points( "
        "id INTEGER PRIMARY KEY, "
        "sm_trend_id INTEGER NOT NULL, "
        "minute REAL NOT NULL, "
        "amount REAL NOT NULL, "
        " "
        "FOREIGN KEY(sm_trend_id) REFERENCES trends(sm_id), "
        "UNIQUE(sm_trend_id, minute) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_TRENDS
    {
        "CREATE TABLE trends( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "sm_fixture_id INTEGER NOT NULL, "
        "sm_team_id INTEGER NOT NULL, "
        "type TEXT NOT NULL, "
        "updated_at TEXT NOT NULL, "
        "timezone_type INTEGER NOT NULL, "
        "timezone TEXT NOT NULL, "
        " "
        "FOREIGN KEY(sm_fixture_id) REFERENCES fixtures(sm_id), "
        "FOREIGN KEY(sm_team_id) REFERENCES teams(sm_id), "
        "UNIQUE(sm_fixture_id, sm_team_id, type) "
        "); "
        
	};
    
    const std::string CREATE_TABLE_VENUES
    {
        "CREATE TABLE venues( "
        "id INTEGER PRIMARY KEY, "
        "sm_id INTEGER NOT NULL UNIQUE, "
        "name TEXT NOT NULL UNIQUE, "
        "surface TEXT, "
        "address TEXT, "
        "city TEXT NOT NULL, "
        "capacity INTEGER, "
        "image_path TEXT, "
        "coordinates TEXT "
        "); "
        
	};
    
    
}